<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2008 Ruslan R. Fazliev <rrf@rrf.ru>                      |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  RUSLAN  R. |
| FAZLIEV (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  OR MAKING |
| AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE  "SOFTWARE").   |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev             |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2008           |
| Ruslan R. Fazliev. All Rights Reserved.                                     |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: cc_quantum_tqgwdbe.php,v 1.0 2008/11/13 11:01:52 ferz Exp $
#
# Quantum Gateway Transparent DB Engine
#
if (!defined('XCART_START')) { header("Location: ../"); die("Access denied"); }

x_load('http');


$avserr = array(
	"A" => "Address (Street) matches, ZIP does not",
	"E" => "AVS error",
	"N" => "No Match on Address (Street) or ZIP",
	"P" => "AVS not applicable for this transaction",
	"R" => "Retry. System unavailable or timed out",
	"S" => "Service not supported by issuer",
	"U" => "Address information is unavailable",
	"W" => "9 digit ZIP matches, Address (Street) does not",
	"X" => "Exact AVS Match",
	"Y" => "Address (Street) and 5 digit ZIP match",
	"Z" => "5 digit ZIP matches, Address (Street) does not"
);

$cvverr = array(
	"M" => "Match",
	"N" => "No Match",
	"P" => "Not Processed",
	"S" => "Should have been present",
	"U" => "Issuer unable to process request"
);


$post = array();

$post[] = "gwlogin="		. $module_params["param01"];
if ($module_params["param08"] == "Y") {
	$post[] = "RestrictKey="	. $module_params['param02'];
}
$post[] = "trans_type=" 	. $module_params['param03'];
$post[] = "trans_method=CC";
$post[] = "ccnum=" 			. $userinfo["card_number"];
$post[] = "ccyr=" 			. substr($userinfo["card_expire"], 2,2);
$post[] = "ccmo="			. substr($userinfo["card_expire"], 0,2);
$post[] = "BADDR1=" 		. $userinfo["b_address"];
$post[] = "BZIP1=" 			. $userinfo["b_zipcode"];
$post[] = "FNAME=" 			. $userinfo["firstname"];
$post[] = "LNAME=" 			. $userinfo["lastname"];
$post[] = "BCITY=" 			. $userinfo["b_city"];
$post[] = "BSTATE="			. ((!empty($userinfo["b_state"]) && $userinfo["b_state"]!="Other")? $userinfo["b_state"] : "Non US");
$post[] = "BCOUNTRY="		. $userinfo["b_country"];
$post[] = "SFNAME="			. ($userinfo["s_firstname"]?$userinfo["s_firstname"]:$userinfo["firstname"]);
$post[] = "SLNAME="			. ($userinfo["s_lastname"]?$userinfo["s_lastname"]:$userinfo["lastname"]);
$post[] = "SADDR1="			. $userinfo["s_address"];
$post[] = "SCITY="			. $userinfo["s_city"];
$post[] = "SSTATE="			. ((!empty($userinfo["s_state"]) && $userinfo["s_state"]!="Other")? $userinfo["s_state"] : "Non US");
$post[] = "SZIP1="			. $userinfo["s_zipcode"];
$post[] = "SCOUNTRY="		. $userinfo["s_country"];
$post[] = "phone="			. $userinfo["phone"];
$post[] = "Company="		. $userinfo["company"];
$post[] = "BCUST_EMAIL="	. $userinfo["email"];	
$post[] = "invoice_num="	. $module_params["param04"].join("-",$secure_oid); 
$post[] = "invoice_description="	. "Order(s) #".join("-",$secure_oid)."; customer: ".$userinfo['login'];
$post[] = "cust_id=" 		. $userinfo['login'];
$post[] = "customer_ip="	. $_SERVER['REMOTE_ADDR'];
$post[] = "override_email_customer=". $module_params["param05"];
$post[] = "override_trans_email="	. $module_params["param06"];
$post[] = "MAXMIND="				. $module_params["param07"];
$post[] = "salesTaxAmount="			. $cart['tax_cost'];
$post[] = "amount="			. price_format($cart["total_cost"]);
$post[] = "Dsep=Pipe";
if (!empty($userinfo["card_cvv2"])) {
	$post[] = "CVV2="	. $userinfo["card_cvv2"];
	$post[] = "CVVtype=1"; 
} else {
	$post[] = "CVVtype=0";
}

list($a,$return) = func_https_request("POST","https://secure.quantumgateway.com/cgi/tqgwdbe.php",$post);

$return = explode("|", $return);
$result = array();

for ($i=0; $i<count($return); $i++) {
	$result[$i] = str_replace('"', '', $return[$i]);
}

//Transaction Status, Auth Code, Transaction ID, AVS Response, CVV2 Response, Maxmind Score, Decline Reason, Decline Error Number

if ($result[0] == "APPROVED") {
	$bill_output['code'] = 1;
	$bill_output['billmes'] = "Approved. Transaction ID: " . $result[2] . ". Auth Code: " . $result[1];

} else {
	$bill_output['code'] = 2;
	$bill_output['billmes'] = "Declined: Result code: " . $result[7] . ". Message: " . $result[6];
	if ($module_params['param03'] == "AUTH_CAPTURE") {
		$bill_output['billmes'] .= ". AVS Response: " . $avserr[$result[3]];
		$bill_output['billmes'] .= ". CVV2 Response: " . $cvverr[$result[4]];
		$bill_output["cvvmes"] = "CVV2 Response: ". $cvverr[$result[4]];
		$bill_output["avsmes"] = "AVS Response: ".$avserr[$result[3]];
	}
}


?>